diff --git a/src/lib/render.c b/src/lib/render.c
index fbd2f87ef..958cb0059 100644
--- a/src/lib/render.c
+++ b/src/lib/render.c
@@ -429,8 +429,9 @@ fprintf(stderr, "Merging down %d/%d @ %d/%d to %d/%d\n", leny, lenx, begsrcy, be
              leny, lenx, src->leny, src->lenx);
     return -1;
   }
-  cell* rendfb = calloc(sizeof(*rendfb), leny * lenx);
-  const size_t crenderlen = sizeof(struct crender) * leny * lenx;
+  const int totalcells = dst->leny * dst->lenx;
+  cell* rendfb = calloc(sizeof(*rendfb), totalcells);
+  const size_t crenderlen = sizeof(struct crender) * totalcells;
   struct crender* rvec = malloc(crenderlen);
   if(!rendfb || !rvec){
     logerror(dst->nc, "Error allocating render state for %dx%d\n", leny, lenx);
@@ -439,17 +440,21 @@ fprintf(stderr, "Merging down %d/%d @ %d/%d to %d/%d\n", leny, lenx, begsrcy, be
     return -1;
   }
   init_rvec(rvec, leny * lenx);
-  if(paint(src, rvec, dst->leny, dst->lenx, dst->absy, dst->absx)){
+fprintf(stderr, "Merging SRC (%dx%d @ %dx%d)\n", dst->leny, dst->lenx, dst->absy, dst->absx);
+  if(paint(src, rvec, dst->leny, dst->lenx, 0, 0)){
     free(rvec);
     free(rendfb);
     return -1;
   }
-  if(paint(dst, rvec, dst->leny, dst->lenx, dst->absy, dst->absx)){
+fprintf(stderr, "Merging DST (%dx%d @ %dx%d)\n", dst->leny, dst->lenx, dst->absy, dst->absx);
+  if(paint(dst, rvec, dst->leny, dst->lenx, 0, 0)){
     free(rvec);
     free(rendfb);
     return -1;
   }
+fprintf(stderr, "Postpaint start (%dx%d)\n", dst->leny, dst->lenx);
   postpaint(rendfb, dst->leny, dst->lenx, rvec, &dst->pool);
+fprintf(stderr, "Postpaint done (%dx%d)\n", dst->leny, dst->lenx);
   free(dst->fb);
   dst->fb = rendfb;
   free(rvec);
